<style>
    .regular-text {
        padding: 7px;
    }
    #header_text {
        margin-top: 20px;
        border-bottom: 1px solid #ccc;
        padding-bottom: 9px;
    }
</style>
<h1 id="header_text">Smartech Configuration</h1>
<div id="main-container">
    <div id="basic_setting">
        <h3>Basic Settings</h3>
        <div id="setting-error-settings_updated" style="display: none" class="updated settings-error notice is-dismissible"> 

        </div>
        <table class="form-table">
            <tr>
                <th>
                    Web Tracking Id
                </th>
                <td>
                    <input type="text" id="web_tracking_id" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>Site Id</th>
                <td>
                    <input type="text" id="siteid" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>Smartech Primary Key</th>
                <td>
                    <input type="text" id="smt_pk" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>Smartech List Id</th>
                <td>
                    <input type="text" id="listid" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>Select your IDC</th>
                <td>
                    <select id="idc" name="idc">
                        <option value="">US IDC</option>
                        <option value="tin">Indian IDC</option>
                        <option value="eu">Europe IDC</option>
                    </select>
                </td>
            </tr>
            <tr>
                <th>Enable Tracking</th>
                <td>
                    <input type="radio" id="track_status_enable" value="enable" name="track_status" class=""/>
                    <label for="track_status_enable">Enable</label>
                    <input type="radio" id="track_status_disable" value="disable" name="track_status" class=""/>
                    <label for="track_status_disable">Disable</label>
                </td>
            </tr>
            <tr>
                <th colspan="2">
                    <input type="checkbox" id="enable_wpn" value="enable" name="enable_wpn" class=""/>
                    <label for="enable_wpn">Enable Web Push Notification</label>
                </th>
                <td>

                </td>
            </tr>
        </table>
        <table class="form-table" id="wpn_settings_icon">
            <tr>
                <th>
                    WPN Default icon url
                </th>
                <td>
                    <input type="text" id="web_push_icon" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>
                    Panel's API key
                </th>
                <td>
                    <input type="text" id="web_push_apikey" class="regular-text"/>
                </td>
            </tr>
        </table>
        <table class="form-table" id="wpn_settings" style="display: none">
            <tr>
                <th>FCM Api Key</th>
                <td>
                    <input type="text" id="bpn_api_key" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>FCM Sender Id</th>
                <td>
                    <input type="text" id="bpn_sender_id" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>FCM Project Id</th>
                <td>
                    <input type="text" id="bpn_project_id" class="regular-text"/>
                </td>
            </tr>
            <tr>
                <th>FCM App Id</th>
                <td>
                    <input type="text" id="bpn_app_id" class="regular-text"/>
                </td>
            </tr>
        </table>
        <p class="submit">
            <input id="submit_basic" onclick="saveConfiguration()" class="button button-primary" value="Save Changes" type="button">
        </p>
    </div>
</div>

<script type="text/javascript">
    var $ = jQuery;
    function fetchConfiguration() {
        var confPromise = new Promise(function (resolve, reject) {
            $.ajax({
                url: ajaxurl,
                type: 'POST',
                dataType: 'json',
                data: {action: 'get_smartech_configration'},
                success: function (data) {
                    resolve(data);
                }
            });
        });
        return confPromise;
    }

    function updateForm(data) {
        var webData = data.data || {};
        $('#web_tracking_id').val(webData.web_tracking_id);
        $('#siteid').val(webData.siteid);
        $('#smt_pk').val(webData.smt_pk);
        $('#listid').val(webData.listid);
        $('#idc').val(webData.idc);
        var status_id = '#track_status_disable';
        if (webData.track_status === 'enable') {
            status_id = '#track_status_enable';
        }
        $(status_id).prop('checked', true);
        if (webData.bpn_enable || (webData.bpn_sender_id && webData.bpn_api_key)) {
            $('#wpn_settings_icon').show();
            $('#enable_wpn').prop('checked', true);
            $('#web_push_icon').val(webData.web_push_icon);
            $('#web_push_apikey').val(webData.web_push_apikey);
            $('#wpn_settings').show();
            $('#bpn_api_key').val(webData.bpn_api_key);
            $('#bpn_sender_id').val(webData.bpn_sender_id);
            $('#bpn_app_id').val(webData.bpn_app_id);
            $('#bpn_project_id').val(webData.bpn_project_id);
        } else {
            $('#wpn_settings_icon').hide();
            $('#wpn_settings').hide();
        }
    }

    function validateFormData(data) {
        if (data.web_tracking_id === '') {
            alert('Smartech web tracking id is required');
            return false;
        } else if (data.siteid === '') {
            alert('Smartech site id is required');
            return false;
        } else if (data.smt_pk === '') {
            alert('Smartech primary key is required');
            return false;
        }
        if (data.bpn_enable === 1) {
            if (data.bpn_api_key === '') {
                alert('FCM api key is required');
                return false;
            } else if (data.bpn_sender_id === '') {
                alert('FCM sender id is required');
                return false;
            } else if (data.bpn_project_id === '') {
                alert('FCM project id is required');
                return false;
            } else if (data.bpn_app_id === '') {
                alert('FCM app id is required');
                return false;
            }
            if (data.web_push_icon) {
                if (data.web_push_icon.match(/\.(jpeg|jpg|gif|png)$/) === null || !data.web_push_icon.match(/^https:\/\//)) {
                    alert('Please enter valid icon image URL');
                    return false;
                }
            }
            
        }
        return true;
    }

    function saveConfiguration() {
        var web_tracking_id = $('#web_tracking_id').val().trim() || '',
            siteid = $('#siteid').val().trim() || '',
            smt_pk = $('#smt_pk').val().trim() || '',
            track_status = $("input[name='track_status']:checked").val().trim() || 'disabled',
            listid = $('#listid').val().trim() || 0;
            idc = $('#idc').val() || '';
        var data = {
            web_tracking_id: web_tracking_id,
            siteid: siteid,
            smt_pk: smt_pk,
            track_status: track_status,
            listid: listid,
            idc: idc,
            bpn_enable: 0,
            action: 'post_smartech_configuration'
        };
        if ($('#enable_wpn').is(':checked') === true) {
            data['bpn_api_key'] = $('#bpn_api_key').val().trim() || '';
            data['bpn_sender_id'] = $('#bpn_sender_id').val().trim() || '';
            data['bpn_project_id'] = $('#bpn_project_id').val().trim() || '';
            data['bpn_app_id'] = $('#bpn_app_id').val().trim() || '';
            //data['bpn_enable'] = true;
            data.web_push_icon = $('#web_push_icon').val().trim() || '';
            data.web_push_apikey = $('#web_push_apikey').val().trim() || '';
            data.bpn_enable = 1;
        } else {
            $('#bpn_api_key').val('');
            $('#bpn_sender_id').val('');
            $('#bpn_project_id').val('');
            $('#bpn_app_id').val('');
            $('#web_push_icon').val('');
            $('#web_push_apikey').val('');
        }
        if (validateFormData(data) === false) {
            return;
        }
        
        $.ajax({
            url: ajaxurl,
            type: 'POST',
            data: data,
            success: function (data) {
                alert('Setting saved');
            }
        });
    }


    $(document).ready(function () {
        fetchConfiguration().then(function (data) {
            updateForm(data);
        });
        $('#enable_wpn').click(function () {
            if ($(this).is(':checked') === true) {
                $('#wpn_settings').show();
                $('#wpn_settings_icon').show();
            } else {
                $('#wpn_settings').hide();
                $('#wpn_settings_icon').hide();
            } 
        });
    });
</script>
