<?php

/**
 * @package Smartech
 */
/*
  Plugin Name: Smartech
  Plugin URI: https://netcore.in/
  Description: This plugin will help marketer to integrate their wordpress E-commerce sites to Netcore Smartech. There will be no requirement of developer for the integration of smartech js tag to track user's activity as well as send Browser push Notification.
  Version: 0.1
  Author: Netcore
 */
if (!function_exists('add_action')) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}
define("SMARTECH_SERVER_URL", "//cdnt.netcoresmartech.com/");
define('SMARTECH__PLUGIN_DIR', plugin_dir_path(__FILE__));
define("SMARTECH_SCRIPT_PATH", SMARTECH_SERVER_URL . "smartechclient.js");
define("SMARTECH_SW_PATH", SMARTECH_SERVER_URL . "swv4.js");
require_once( SMARTECH__PLUGIN_DIR . 'class.smartech.php' );
register_activation_hook(__FILE__, array('Smartech', 'plugin_activation'));
register_deactivation_hook(__FILE__, array('Smartech', 'plugin_deactivation'));
add_action('init', array('Smartech', 'init'));


function smartech_add_custom_box() {
  add_meta_box(
      'smartech_notify',
      'Smartech Push Notifications',
      'smartech_notify_html',
      'post',
      'side',
      'high'
  );
}
function smartech_notify_html($post) {
  include_once( 'class.smartech.php' );
  $sm_obj = new Smartech();
  $editor_script = 'sm_notification';
  wp_enqueue_script( $editor_script );
  $smartech_notify_title = $sm_obj->sm_get_option( 'smartech_notify_title_'.$post->ID); 
  $smartech_notify_message = $sm_obj->sm_get_option( 'smartech_notify_message_'.$post->ID);
  //$smartech_ttl = $sm_obj->sm_get_option( 'smartech_ttl_'.$post->ID);
  $smartech_notify_opt = $sm_obj->sm_get_option( 'smartech_notify_opt_'.$post->ID);
  $smartech_setsitetitle_opt = $sm_obj->sm_get_option( 'smartech_setsitetitle_opt_'.$post->ID);
  $smartech_freq_cap_opt = $sm_obj->sm_get_option( 'smartech_freq_cap_opt_'.$post->ID);
  $smartech_autohide_opt = $sm_obj->sm_get_option( 'smartech_autohide_opt_'.$post->ID);
  $smartech_wptitle = get_bloginfo('name');

  $notify = $title = $freq = $auto = "";
  if (!empty($smartech_notify_opt)) { $notify = "checked"; }
  if (!empty($smartech_setsitetitle_opt)) { $title = "checked"; }
  if (!empty($smartech_freq_cap_opt)) { $freq = "checked"; }
  if (!empty($smartech_autohide_opt)) { $auto = "checked"; }
  
  echo '<input type="checkbox" name="smartech_notify_opt" id="smartech_notify_opt" value="1"'. $notify .'>';
  //wp_nonce_field( basename( __FILE__ ), 'smartech_notify_opt_nonce' );
  echo '<label for="smartech_notify_opt"> &nbsp;Send notification on post publish</label><br/><br/>';
  echo '<input type="checkbox" name="smartech_setsitetitle_opt" id="smartech_setsitetitle_opt" value="1" '. $title .' >';
  //wp_nonce_field( basename( __FILE__ ), 'smartech_setsitetitle_opt_nonce' );
  echo '<label for="smartech_setsitetitle_opt"> &nbsp;Use site and post title as notification title and message respectively.</label><br/><br/>';
  echo '<input type="checkbox" name="smartech_freq_cap_opt" id="smartech_freq_cap_opt" 
  value="1" '.$freq.' >';
  //wp_nonce_field( basename( __FILE__ ), 'smartech_freq_cap_opt_nonce' );
  echo '<label for="smartech_freq_cap_opt"> &nbsp;Skip frequency capping</label><br/><br/>';
  echo '<input type="checkbox" name="smartech_autohide_opt" id="smartech_autohide_opt" 
  value="1" '.$auto.' >';
  //wp_nonce_field( basename( __FILE__ ), 'smartech_autohide_opt_nonce' );
  echo '<label for="smartech_autohide_opt"> &nbsp;Autohide campaign</label><br/><br/>';
  echo 'Title <span style="color:red">*</span><br>';
  echo '<input type="hidden" name="smartech_wptittle" id="smartech_wptittle" value="'.$smartech_wptitle.'" /><input type="text" placeholder="Title" name="smartech_notify_title" id="smartech_notify_title"  style="width:100%" value="'.$smartech_notify_title.'"><br/><br/>';
  echo 'Message <span style="color:red">*</span><br>';
  echo '<textarea name="smartech_notify_message" id="smartech_notify_message" style="width:100%" placeholder="Message">'.$smartech_notify_message.'</textarea><br/>';
  //echo '<input type="number" placeholder="Max 3000" name="smartech_ttl" id="smartech_ttl"  style="width:100%" value="'.$smartech_ttl.'"><br/> Time to leave in seconds';
}
function sm_save_postdata( $post_id, $post ) {
  include_once( 'class.smartech.php' );
  $sm_obj = new Smartech();
  if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
            return;
        }
 if (defined('DOING_AJAX') && DOING_AJAX) {
            return;
        }
 if (!current_user_can('edit_post', $post_id)) {
            return;
        }
 if (false !== wp_is_post_revision($post_id)) {
            return;
        }

  $sm_obj->sm_update_option( 'smartech_notify_title_'.$post->ID, trim($_POST['smartech_notify_title']) );
  $sm_obj->sm_update_option( 'smartech_notify_message_'.$post->ID, trim($_POST['smartech_notify_message']) );
  //$sm_obj->sm_update_option( 'smartech_ttl_'.$post->ID, $_POST['smartech_ttl'] );

  $sm_obj->sm_update_option( 'smartech_notify_opt_'.$post->ID, $_POST['smartech_notify_opt'] );
  $sm_obj->sm_update_option( 'smartech_setsitetitle_opt_'.$post->ID, $_POST['smartech_setsitetitle_opt'] );
  $sm_obj->sm_update_option( 'smartech_freq_cap_opt_'.$post->ID, $_POST['smartech_freq_cap_opt'] );
  $sm_obj->sm_update_option( 'smartech_autohide_opt_'.$post->ID, $_POST['smartech_autohide_opt'] );
  //echo "<pre>"; print_r($post); echo "<pre>"; print_r($_POST); die;
  //return true;
}
function register_sm_scripts() {
  wp_register_script( 'sm_notification', plugin_dir_url(__FILE__) . 'sm_notification.js' );
}
function post_published_notification($post_id, $post) { 
  $user_data = wp_get_current_user();
  $save_data = sm_save_postdata( $post_id, $post );
  include_once( 'class.smartech.php' );
  $sm_obj = new Smartech();
  $settings_data = $sm_obj->get_conficuration("plain");
  if(!empty($sm_obj->sm_get_option( 'smartech_notify_opt_'.$post->ID))) {
    $params = array(
      "notify_me" => $user_data->data->user_email,
      "campaign_name" => 'Webpush - '.$post->ID,
      "website_id" => $settings_data->siteid,
      "list" => "-1",
      "wpn_title" => stripslashes($sm_obj->sm_get_option( 'smartech_notify_title_'.$post->ID)),
      "wpn_content" => stripslashes($sm_obj->sm_get_option( 'smartech_notify_message_'.$post->ID)),
      "cta" => $post->guid,
      "schedule_time" => "now",
      "media_small" => $settings_data->web_push_icon,
      "auto_hide" => ($sm_obj->sm_get_option( 'smartech_autohide_opt_'.$post->ID)) ? 'true' : 'false',
      "skip_frequency" => ($sm_obj->sm_get_option( 'smartech_freq_cap_opt_'.$post->ID)) ? 1 : 0,
      "type"=>'wpn_broadcast',
      "activity"=>'create',
      "apikey"=>$settings_data->web_push_apikey
      //"ttl" => $sm_obj->sm_get_option( 'smartech_ttl_'.$post->ID)
    );
    $post_array = array(
      'data'=>json_encode($params),
      "type"=>'wpn_broadcast',
      "activity"=>'create',
      "apikey"=> $settings_data->web_push_apikey
    );
    $url = $sm_obj->json_api;
    //echo "URL is : ".$url."=> <pre>"; print_r($post_array); 
    $notification_request = curl_call($url, $post_array,'POST'); 
    //echo "<pre>"; print_r($notification_request); die;
    if ($notification_request["response"]["code"] === 200) {
      echo "API called successfully and return status 200";
    } else {
      echo "send monitoring alert to system";
    }
  }
}
function curl_call($url, $data, $type, $custom_header = '', $timeout = 0, $returnWithExtra = false) {
  $ch = curl_init();
  if ($type == "POST") {
    if (!empty($custom_header)) {
      curl_setopt($ch, CURLOPT_HTTPHEADER, $custom_header);
    }
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);
    if (isset($custom_header[0]) && $custom_header[0] == 'Content-Type: application/json') {
      curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    } else {
      curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    }
  } else if ($type == "PATCH") {
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PATCH');
  } else if ($type == "DELETE") {
    curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
  } else if ($type == "JSON") {
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
    curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
    curl_setopt($ch, CURLOPT_POST, 1);
    if (!empty($custom_header)) {
      curl_setopt($ch, CURLOPT_HTTPHEADER, $custom_header);
    }
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_BUFFERSIZE, 10485000);
  } else if ($type == "PUT") {
    curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
  } else {
    curl_setopt($ch, CURLOPT_URL, $url . "?" . http_build_query($data));
  }
  if ($timeout > 0) {
    curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
  }
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // return into a variable
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); //check for https
  $result = curl_exec($ch); // run the whole process
  $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
  $info = curl_getinfo($ch);
  if ($returnWithExtra) {
    $curl_errno = curl_errno($ch);
    $curl_error = curl_error($ch);
    /*
    $return = array(
        'http_code' => $http_status,
        'response' => $result,
        'error_no' => $curl_errno,
        'error' => $curl_error,
        'info' => $info,
    );
    */
    $return = array($http_status, $result, $info, array($curl_errno, $curl_error));
  } else {
    $return = array($http_status, $result);
  }
  curl_close($ch);
  return $return;
}

add_action( 'init','register_sm_scripts' );

//require_once( SMARTECH__PLUGIN_DIR . 'sm_notification.js' );
add_action( 'add_meta_boxes', 'smartech_add_custom_box' );

// Save post action 
add_action( 'save_post', 'sm_save_postdata', 10, 2 );

// publish a post
add_action( 'publish_post', 'post_published_notification', 10, 2 );
